var preProc = {
      apply:  function(c) {
                // extend the bibliography entries

                berjon.biblio["TURTLE"] = "<cite><a href=\"http://www.w3.org/TeamSubmission/2011/SUBM-turtle-20110328/\">Turtle - Terse RDF Triple Language</a></cite> D. Beckett and T. Berners-Lee.  W3C Team Submission 28 March 2011. URL: http://www.w3.org/TeamSubmission/turtle/ ";
                berjon.biblio["XMLSCHEMA2"] = "<cite><a href=\"http://www.w3.org/TR/2011/CR-xmlschema11-2-20110721/\">W3C XML Schema Definition Language (XSD) 1.1 Part 2: Datatypes</a></cite> David Peterson; et al. W3C Proposed Recommendation 19 January 2012. URL: http://www.w3.org/TR/xmlschema11-2/ ";
                berjon.biblio["MICRODATA"] = "<cite><a href=\"http://www.w3.org/TR/microdata/\">Microdata</a></cite> Ian Hickson; et al. 04 March 2010. W3C Working Draft. URL: http://www.w3.org/TR/microdata/ ";
                berjon.biblio["XHTML-RDFA"] = "<cite><a href=\"http://www.w3.org/TR/xhtml-rdfa/\">XHTML+RDFa</a></cite> Manu Sporny; et al. 31 March 2011. W3C Working Draft. URL: http://www.w3.org/TR/xhtml-rdfa/ ";
                berjon.biblio["HTML-RDFA"] = "<cite><a href=\"http://dev.w3.org/html5/rdfa/\">HTML+RDFa</a></cite> Manu Sporny; et al. 24 May 2011. W3C Working Draft. URL: http://dev.w3.org/html5/rdfa/ ";
                berjon.biblio["HOWTO-LODP"] = "<cite><a href=\"http://linkeddata.org/docs/how-to-publish\">How to Publish Linked Data on the Web</a></cite>, C. Bizer, R. Cyganiak, and Tom Heath, Community Tutorial 17 July 2008. URL: http://linkeddata.org/docs/how-to-publish";
                berjon.biblio["COOL-SWURIS"] = "<cite><a href=\"http://www.w3.org/TR/cooluris/\">Cool URIs for the Semantic Web</a></cite>, L. Sauermann and R. Cyganiak, W3C Interest Group Note 03 December 2008. URL: http://www.w3.org/TR/cooluris/";
                berjon.biblio["VOID-GUIDE"] = "<cite><a href=\"http://www.w3.org/TR/void/\">Describing Linked Datasets with the VoID Vocabulary</a></cite>, K. Alexander, R. Cyganiak, M. Hausenblas, and J. Zhao, W3C Interest Group Note 03 March 2011. URL: http://www.w3.org/TR/void/";
                berjon.biblio["RDFA-CORE-PROFILE"] = "<cite><a href=\"http://www.w3.org/profile/rdfa-1.1\">RDFa Core Default Profile</a></cite>, I. Herman, W3C RDF Web Applications Working Group 02 June 2011. URL: http://www.w3.org/profile/rdfa-1.1";
                berjon.biblio["XHTML-RDFA-PROFILE"] = "<cite><a href=\"http://www.w3.org/profile/html-rdfa-1.1\">HTML+RDFa Core Default Profile</a></cite>, I. Herman, W3C RDF Web Applications Working Group 24 May 2011. URL: http://www.w3.org/profile/html-rdfa-1.1";
                berjon.biblio["RFC2616"] = "<cite><a href=\"http://www.w3.org/Protocols/rfc2616/rfc2616.html\">Hypertext Transfer Protocol -- HTTP/1.1</a></cite>, R. Fielding; et al. June 1999. Internet RFC 2616. URL: http://www.w3.org/Protocols/rfc2616/rfc2616.html.";
				berjon.biblio["VCARD-GUIDE"] =  "<cite><a href=\"http://www.w3.org/TR/vcard-rdf/\">Representing vCard Objects in RDF</a></cite>file://localhost/Users/fadi/development/Spec/gld/dcat/index.html";
				berjon.biblio["PROV-O"] =  "<cite><a href=\"http://www.w3.org/TR/prov-o/\">PROV-O: The PROV Ontology</a></cite>T. Lebo, S. Sahoo, and D. McGuinness, URL: http://www.w3.org/TR/2013/REC-prov-o-20130430/";

                // process the document before anything else is done
                var refs = document.querySelectorAll('adef') ;
                for (var i = 0; i < refs.length; i++) {
                    var item = refs[i];
                    var p = item.parentNode ;
                    var con = item.innerHTML ;
                    var sp = document.createElement( 'dfn' ) ;
                    var tit = item.getAttribute('title') ;
                    if (!tit) {
                        tit = con;
                    }
                    sp.className = 'adef' ;
                    sp.title=tit ;
                    sp.innerHTML = con ;
                    p.replaceChild(sp, item) ;
                }
                refs = document.querySelectorAll('aref') ;
                for (var i = 0; i < refs.length; i++) {
                    var item = refs[i];
                    var p = item.parentNode ;
                    var con = item.innerHTML ;
                    var sp = document.createElement( 'a' ) ;
                    sp.className = 'aref' ;
                    sp.setAttribute('title', con);
                    sp.innerHTML = '@'+con ;
                    p.replaceChild(sp, item) ;
                }
                // local datatype references
                refs = document.querySelectorAll('ldtref') ;
                for (var i = 0; i < refs.length; i++) {
                    var item = refs[i];
                    if (!item) continue ;
                    var p = item.parentNode ;
                    var con = item.innerHTML ;
                    var ref = item.getAttribute('title') ;
                    if (!ref) {
                        ref = item.textContent ;
                    }
                    if (ref) {
                        ref = ref.replace(/\n/g, '_') ;
                        ref = ref.replace(/\s+/g, '_') ;
                    }
                    var sp = document.createElement( 'a' ) ;
                    sp.className = 'datatype';
                    sp.title = ref ;
                    sp.innerHTML = con ;
                    p.replaceChild(sp, item) ;
                }
                // external datatype references
                refs = document.querySelectorAll('dtref') ;
                for (var i = 0; i < refs.length; i++) {
                    var item = refs[i];
                    if (!item) continue ;
                    var p = item.parentNode ;
                    var con = item.innerHTML ;
                    var ref = item.getAttribute('title') ;
                    if (!ref) {
                        ref = item.textContent ;
                    }
                    if (ref) {
                        ref = ref.replace(/\n/g, '_') ;
                        ref = ref.replace(/\s+/g, '_') ;
                    }
                    var sp = document.createElement( 'a' ) ;
                    sp.className = 'externalDFN';
                    sp.title = ref ;
                    sp.innerHTML = con ;
                    p.replaceChild(sp, item) ;
                }
                // now do terms
                refs = document.querySelectorAll('tdef') ;
                for (var i = 0; i < refs.length; i++) {
                    var item = refs[i];
                    if (!item) continue ;
                    var p = item.parentNode ;
                    var con = item.innerHTML ;
                    var ref = item.getAttribute('title') ;
                    if (!ref) {
                        ref = item.textContent ;
                    }
                    if (ref) {
                        ref = ref.replace(/\n/g, '_') ;
                        ref = ref.replace(/\s+/g, '_') ;
                    }
                    var sp = document.createElement( 'dfn' ) ;
                    sp.title = ref ;
                    sp.innerHTML = con ;
                    p.replaceChild(sp, item) ;
                }
                // now term references
                refs = document.querySelectorAll('tref') ;
                for (var i = 0; i < refs.length; i++) {
                    var item = refs[i];
                    if (!item) continue ;
                    var p = item.parentNode ;
                    var con = item.innerHTML ;
                    var ref = item.getAttribute('title') ;
                    if (!ref) {
                        ref = item.textContent ;
                    }
                    if (ref) {
                        ref = ref.replace(/\n/g, '_') ;
                        ref = ref.replace(/\s+/g, '_') ;
                    }

                    var sp = document.createElement( 'a' ) ;
                    var id = item.textContent ;
                    sp.className = 'tref' ;
                    sp.title = ref ;
                    sp.innerHTML = con ;
                    p.replaceChild(sp, item) ;
                }
            }
    } ;